<template>
    <app-dialog title="Delete storage" dialog-name="deleteStorage" cancellable>
        <template slot="dialog-content">
            Are you sure you want to remove this storage?
            This action can not be undone.
        </template>

        <template slot="dialog-actions">
            <v-btn
                color="error"
                text
                @click="handleConfirm"
            >
                Delete
            </v-btn>
        </template>
    </app-dialog>

</template>

<script lang="ts">
import { defineComponent, PropType } from "@vue/composition-api";
import { useObservers, useDialogs, useSettings, useContents } from "@/compositions";
import AppDialog from "@/components/dialogs/AppDialog.vue";
import { AppStorage } from "@/ts";
import { deleteStorage } from "@/ipc";

export default defineComponent({
    name: "DeleteStorageDialog",
    components: { AppDialog },
    props: {
        storage: {
            type: Object as PropType<AppStorage>
        }
    },
    setup(props) {
        const appDialogs = useDialogs().getDialogs();

        const handleConfirm = async () => {
            const storage = props.storage as AppStorage;
            await deleteStorage(storage);
            await useSettings().updateStorage();
            await useObservers().notifyObservers('storageDeleted', {
                deletedStorage: storage
            });

            const currentStorage = useContents().getCurrentStorage.value;

            if (currentStorage.path === storage.path) {
                const defaultStorage = useContents().getDefaultStorage.value;

                if (defaultStorage) {
                    useContents().setCurrentStorage(defaultStorage);
                }
            }

            useDialogs().deActivateDialog('deleteStorage');
        }

        return {
            handleConfirm,
            appDialogs
        }
    }
});
</script>

<style scoped>

</style>